
Redmine - Defect #41823

"Stay logged in" feature is not available

2024-11-22 04:04 - Hiromu Kuwahara

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Accounts / authentication Estimated time: 0.00 hour

Target version:    

Resolution: Invalid Affected version: 6.0.1

Description

I get a server error when I log in with `Stay logged in` checked.

Reproduction procedures

1. Launch Redmine v6.0.1 using sameersbn/docker-redmine.

(Note: the official container image is not available due to #41815)

2. Access the Web site and complete the initial setup.

3. Enable `Autologin` from the configuration screen.

4. Log out of the system.

5. If you check auto-login and log in, you will get an error as shown below.

[nginx] access.log

172.26.0.1 - - [22/Nov/2024:07:44:10 +0530] "POST /login HTTP/1.1" 500 5 "http://localhost:10083/l

ogin" "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131

.0.0.0 Safari/537.36" 

 

[redmine] production.log

I, [2024-11-22T07:44:10.049757 #365]  INFO -- : [062463b9-a43b-4ff7-8e83-35840be14a82] Started POS

T "/login" for 172.26.0.1 at 2024-11-22 07:44:10 +0530

I, [2024-11-22T07:44:10.050517 #365]  INFO -- : [062463b9-a43b-4ff7-8e83-35840be14a82] Processing 

by AccountController#login as HTML

I, [2024-11-22T07:44:10.050594 #365]  INFO -- : [062463b9-a43b-4ff7-8e83-35840be14a82]   Parameter

s: {"authenticity_token"=>"E7MHBZMEz3neTRMmvyrkeCQYi4gY4A15JPNEpN2aDTksFWY1vrZPhrTqq7FOj0KqluxAKNf

V3bJzvtuF-PEpog", "username"=>"admin", "password"=>"[FILTERED]", "autologin"=>"1", "login"=>"ログイン"

}

I, [2024-11-22T07:44:10.052669 #365]  INFO -- : [062463b9-a43b-4ff7-8e83-35840be14a82]   Current u

ser: anonymous

I, [2024-11-22T07:44:10.053547 #365]  INFO -- : [062463b9-a43b-4ff7-8e83-35840be14a82] Successful 

authentication for 'admin' from 172.26.0.1 at 2024-11-22 02:14:10 UTC

I, [2024-11-22T07:44:10.070869 #365]  INFO -- : [062463b9-a43b-4ff7-8e83-35840be14a82] Redirected 

to http://localhost:10083/my/page

I, [2024-11-22T07:44:10.071018 #365]  INFO -- : [062463b9-a43b-4ff7-8e83-35840be14a82] Completed 3

02 Found in 20ms (ActiveRecord: 14.0ms (12 queries, 0 cached) | GC: 0.0ms)

 

[redmine] unicorn.stderr.log

E, [2024-11-22T07:44:10.071811 #365] ERROR -- : app error: undefined method `=~' for ["autologin=1

3921327d6ada268ecd3dd51bfd9d68301f1bcbc; path=/; expires=Sat, 22 Nov 2025 02:14:10 GMT; httponly; 

samesite=lax", "_redmine_session=K1AvTTE0cEtVVUl4NE5Jd2pZV3BNckxSK083Sm0xRjJSVUQ5eU5JVDAxYld4eVRWN

GMwZGx1UTc1dklUZDArd1JUMVhSUjlWS3ZzSGhFbUJITUtzRWpQUERqVjBETXJjc0wyRmhyNVkrSzVUK3UvUHQ3am16TEduakd

ObGMyS2pKSTZDKzFvVDJOblFkVEhVeTZLOGxEY01ZWUFpU1NydGhqUUR1aTVLczQ0STlyY2RwclZlazJJT2pQSENudU5rZERXU

FlNWGg4U0Z3ZVJ5M0hVb2NrY0VjL2JIRUNlcktUa2tudGY2V0hSaz0tLXBpcnBFL3g2L2kwRnRURER2Y1UvUFE9PQ%3D%3D--f

334374f684da1ba499cb9506ad3fdddb7fabb76; path=/; httponly; samesite=lax"]:Array (NoMethodError)

E, [2024-11-22T07:44:10.071886 #365] ERROR -- : /home/redmine/data/tmp/bundle/ruby/3.2.0/gems/unic

orn-6.1.0/lib/unicorn/http_response.rb:43:in `block in http_response_write'

E, [2024-11-22T07:44:10.071905 #365] ERROR -- : /home/redmine/data/tmp/bundle/ruby/3.2.0/gems/unic

orn-6.1.0/lib/unicorn/http_response.rb:34:in `each'
E, [2024-11-22T07:44:10.072139 #365] ERROR -- : /home/redmine/data/tmp/bundle/ruby/3.2.0/gems/unic

orn-6.1.0/lib/unicorn/http_response.rb:34:in `http_response_write'

E, [2024-11-22T07:44:10.072159 #365] ERROR -- : /home/redmine/data/tmp/bundle/ruby/3.2.0/gems/unic

orn-6.1.0/lib/unicorn/http_server.rb:645:in `process_client'

E, [2024-11-22T07:44:10.072168 #365] ERROR -- : /home/redmine/data/tmp/bundle/ruby/3.2.0/gems/unic

orn-6.1.0/lib/unicorn/http_server.rb:739:in `worker_loop'

E, [2024-11-22T07:44:10.072176 #365] ERROR -- : /home/redmine/data/tmp/bundle/ruby/3.2.0/gems/unic

orn-6.1.0/lib/unicorn/http_server.rb:547:in `spawn_missing_workers'

E, [2024-11-22T07:44:10.072184 #365] ERROR -- : /home/redmine/data/tmp/bundle/ruby/3.2.0/gems/unic

orn-6.1.0/lib/unicorn/http_server.rb:143:in `start'

E, [2024-11-22T07:44:10.072191 #365] ERROR -- : /home/redmine/data/tmp/bundle/ruby/3.2.0/gems/unic

orn-6.1.0/bin/unicorn_rails:209:in `<top (required)>'

E, [2024-11-22T07:44:10.072198 #365] ERROR -- : /home/redmine/redmine/vendor/bundle/ruby/3.2.0/bin

/unicorn_rails:25:in `load'

E, [2024-11-22T07:44:10.072206 #365] ERROR -- : /home/redmine/redmine/vendor/bundle/ruby/3.2.0/bin

/unicorn_rails:25:in `<top (required)>'

E, [2024-11-22T07:44:10.072213 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

cli/exec.rb:58:in `load'

E, [2024-11-22T07:44:10.072221 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

cli/exec.rb:58:in `kernel_load'

E, [2024-11-22T07:44:10.072228 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

cli/exec.rb:23:in `run'

E, [2024-11-22T07:44:10.072235 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

cli.rb:456:in `exec'

E, [2024-11-22T07:44:10.072243 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

vendor/thor/lib/thor/command.rb:28:in `run'

E, [2024-11-22T07:44:10.072264 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

vendor/thor/lib/thor/invocation.rb:127:in `invoke_command'

E, [2024-11-22T07:44:10.072286 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

vendor/thor/lib/thor.rb:527:in `dispatch'

E, [2024-11-22T07:44:10.072301 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

cli.rb:35:in `dispatch'

E, [2024-11-22T07:44:10.072311 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

vendor/thor/lib/thor/base.rb:584:in `start'

E, [2024-11-22T07:44:10.072319 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

cli.rb:29:in `start'

E, [2024-11-22T07:44:10.072326 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/exe/bundle:2

8:in `block in <top (required)>'

E, [2024-11-22T07:44:10.072341 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/lib/bundler/

friendly_errors.rb:117:in `with_friendly_errors'

E, [2024-11-22T07:44:10.072349 #365] ERROR -- : /usr/local/bundle/gems/bundler-2.5.23/exe/bundle:2

0:in `<top (required)>'

E, [2024-11-22T07:44:10.072357 #365] ERROR -- : /usr/local/bundle/bin/bundle:25:in `load'

E, [2024-11-22T07:44:10.072364 #365] ERROR -- : /usr/local/bundle/bin/bundle:25:in `<main>'

 

ruby bin/about

Environment:

    Redmine version                6.0.1.stable

    Ruby version                   3.2.6-p234 (2024-10-30) [x86_64-linux]

    Rails version                  7.2.2

    Environment                    production

    Database adapter               Mysql2

    Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

    Mailer delivery                smtp

  Redmine settings:

    Redmine theme                  Default

  SCM:

    Subversion                     1.14.2

    Mercurial                      6.3.2

    Cvs                            1.12.13

    Bazaar                         3.3.2

    Git                            2.39.5

    Filesystem                     

  Redmine plugins:

    no plugin installed
History

#1 - 2024-11-22 08:12 - Mizuki ISHIKAWA

By using the `sameersbn/redmine` image, I was able to reproduce the issue. Additionally, exceptions occur not only when logging in but also when

logging out.

Since I couldn’t reproduce the issue in my environment, I investigated the logs and found that the problem seems to be related to Unicorn.

```

undefined method `=~' for ["autologin=1a5e14f455aee651020ccfddd26d35e5d6376f6b; path=/; expires=Sat, 22 Nov 2025 06:47:35 GMT; httponly;

samesite=lax", "_redmine_session=xxxxxxxx; path=/; httponly; samesite=lax"]:Array (NoMethodError)

/home/redmine/data/tmp/bundle/ruby/3.2.0/gems/unicorn-6.1.0/lib/unicorn/http_response.rb:43:in `block in http_response_write'

```

The same issue is reported [here on Stack Overflow](

https://stackoverflow.com/questions/78585543/unicorn-500-code-app-error-undefined-method-for-array-nomethoderror), where it is explained that the

root cause is Rack 3 is unsupported by unicorn 6.1.0 .

#2 - 2024-11-22 08:29 - Mizuki ISHIKAWA

https://stackoverflow.com/questions/78585543/unicorn-500-code-app-error-undefined-method-for-array-nomethoderror

The error is dependency related:

Rack 3 is unsupported by unicorn 6.1.0

Rack 3 uses arrays in response headers now, which unicorn does not yet handle.

#3 - 2024-11-22 10:29 - Hiromu Kuwahara

Thank you for your reply. I understand.

It seems that this problem was not one that should have been written to redmine.org, I'm Sorry.

I will talk to the maintaner of `sameersbn/redmine` to see if there is a solution.

#4 - 2024-11-22 10:32 - Marius BĂLTEANU

- Status changed from New to Closed

- Resolution set to Invalid

#5 - 2024-11-25 15:50 - Jonathan Cormier

Thanks for looking into this.

Adding link to sameersbn/redmine issue: https://github.com/sameersbn/docker-redmine/issues/569

It looks like unicorn hasn't had a release since 2021.  Is it recommended to use something else?

#6 - 2024-11-25 22:23 - Jonathan Cormier

I'm going to switch over to puma.

#7 - 2024-11-26 10:46 - Hiromu Kuwahara

Thank you for your response!

I will try it as soon as the fixed version is released.
